/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse ConfigParser_parse
#define yylex   ConfigParser_lex
#define yyerror ConfigParser_error
#define yylval  ConfigParser_lval
#define yychar  ConfigParser_char
#define yydebug ConfigParser_debug
#define yynerrs ConfigParser_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PRTOKEN_PIXEL_ATTRIBUTES = 258,
     PRTOKEN_SET_SIMPLE = 259,
     PRTOKEN_VISUAL_ID = 260,
     PRTOKEN_BUFFER_SIZE = 261,
     PRTOKEN_LEVEL = 262,
     PRTOKEN_RGBA = 263,
     PRTOKEN_DOUBLEBUFFER = 264,
     PRTOKEN_STEREO = 265,
     PRTOKEN_AUX_BUFFERS = 266,
     PRTOKEN_RED_SIZE = 267,
     PRTOKEN_GREEN_SIZE = 268,
     PRTOKEN_BLUE_SIZE = 269,
     PRTOKEN_ALPHA_SIZE = 270,
     PRTOKEN_DEPTH_SIZE = 271,
     PRTOKEN_STENCIL_SIZE = 272,
     PRTOKEN_ACCUM_RED_SIZE = 273,
     PRTOKEN_ACCUM_GREEN_SIZE = 274,
     PRTOKEN_ACCUM_BLUE_SIZE = 275,
     PRTOKEN_ACCUM_ALPHA_SIZE = 276,
     PRTOKEN_SAMPLES = 277,
     PRTOKEN_SAMPLE_BUFFERS = 278,
     PRTOKEN_RENDER_SURFACE = 279,
     PRTOKEN_WINDOW_RECT = 280,
     PRTOKEN_INPUT_RECT = 281,
     PRTOKEN_HOSTNAME = 282,
     PRTOKEN_DISPLAY = 283,
     PRTOKEN_SCREEN = 284,
     PRTOKEN_BORDER = 285,
     PRTOKEN_DRAWABLE_TYPE = 286,
     PRTOKEN_WINDOW_TYPE = 287,
     PRTOKEN_PBUFFER_TYPE = 288,
     PRTOKEN_CAMERA_GROUP = 289,
     PRTOKEN_CAMERA = 290,
     PRTOKEN_PROJECTION_RECT = 291,
     PRTOKEN_LENS = 292,
     PRTOKEN_FRUSTUM = 293,
     PRTOKEN_PERSPECTIVE = 294,
     PRTOKEN_ORTHO = 295,
     PRTOKEN_OFFSET = 296,
     PRTOKEN_ROTATE = 297,
     PRTOKEN_TRANSLATE = 298,
     PRTOKEN_SCALE = 299,
     PRTOKEN_SHEAR = 300,
     PRTOKEN_CLEAR_COLOR = 301,
     PRTOKEN_INPUT_AREA = 302,
     PRTOKEN_ERROR = 303,
     PRTOKEN_IDENTIFIER = 304,
     PRTOKEN_INTEGER = 305,
     PRTOKEN_HEX_INTEGER = 306,
     PRTOKEN_FLOAT = 307,
     PRTOKEN_TRUE = 308,
     PRTOKEN_FALSE = 309,
     PRTOKEN_QUOTED_STRING = 310,
     PRTOKEN_STEREO_SYSTEM_COMMANDS = 311,
     PRTOKEN_CUSTOM_FULL_SCREEN_RECTANGLE = 312,
     PRTOKEN_METHOD = 313,
     PRTOKEN_PREMULTIPLY = 314,
     PRTOKEN_POSTMULTIPLY = 315,
     PRTOKEN_OVERRIDE_REDIRECT = 316,
     PRTOKEN_SHARELENS = 317,
     PRTOKEN_SHAREVIEW = 318,
     PRTOKEN_READ_DRAWABLE = 319,
     PRTOKEN_SET_RTT_MODE = 320,
     PRTOKEN_RTT_MODE_NONE = 321,
     PRTOKEN_RTT_MODE_RGB = 322,
     PRTOKEN_RTT_MODE_RGBA = 323,
     PRTOKEN_THREAD_MODEL = 324,
     PRTOKEN_SINGLE_THREADED = 325,
     PRTOKEN_THREAD_PER_CAMERA = 326,
     PRTOKEN_THREAD_PER_RENDER_SURFACE = 327,
     PRTOKEN_STEREO_SETTINGS = 328,
     PRTOKEN_MODE = 329,
     PRTOKEN_MONO = 330,
     PRTOKEN_ANAGLYPHIC = 331,
     PRTOKEN_QUAD_BUFFER = 332,
     PRTOKEN_VERTICAL_INTERLACE = 333,
     PRTOKEN_HORIZONTAL_INTERLACE = 334,
     PRTOKEN_EYE_SEPARATION = 335,
     PRTOKEN_SCENE_HANDLER = 336,
     PRTOKEN_AUTO_NEAR_FAR = 337
   };
#endif
/* Tokens.  */
#define PRTOKEN_PIXEL_ATTRIBUTES 258
#define PRTOKEN_SET_SIMPLE 259
#define PRTOKEN_VISUAL_ID 260
#define PRTOKEN_BUFFER_SIZE 261
#define PRTOKEN_LEVEL 262
#define PRTOKEN_RGBA 263
#define PRTOKEN_DOUBLEBUFFER 264
#define PRTOKEN_STEREO 265
#define PRTOKEN_AUX_BUFFERS 266
#define PRTOKEN_RED_SIZE 267
#define PRTOKEN_GREEN_SIZE 268
#define PRTOKEN_BLUE_SIZE 269
#define PRTOKEN_ALPHA_SIZE 270
#define PRTOKEN_DEPTH_SIZE 271
#define PRTOKEN_STENCIL_SIZE 272
#define PRTOKEN_ACCUM_RED_SIZE 273
#define PRTOKEN_ACCUM_GREEN_SIZE 274
#define PRTOKEN_ACCUM_BLUE_SIZE 275
#define PRTOKEN_ACCUM_ALPHA_SIZE 276
#define PRTOKEN_SAMPLES 277
#define PRTOKEN_SAMPLE_BUFFERS 278
#define PRTOKEN_RENDER_SURFACE 279
#define PRTOKEN_WINDOW_RECT 280
#define PRTOKEN_INPUT_RECT 281
#define PRTOKEN_HOSTNAME 282
#define PRTOKEN_DISPLAY 283
#define PRTOKEN_SCREEN 284
#define PRTOKEN_BORDER 285
#define PRTOKEN_DRAWABLE_TYPE 286
#define PRTOKEN_WINDOW_TYPE 287
#define PRTOKEN_PBUFFER_TYPE 288
#define PRTOKEN_CAMERA_GROUP 289
#define PRTOKEN_CAMERA 290
#define PRTOKEN_PROJECTION_RECT 291
#define PRTOKEN_LENS 292
#define PRTOKEN_FRUSTUM 293
#define PRTOKEN_PERSPECTIVE 294
#define PRTOKEN_ORTHO 295
#define PRTOKEN_OFFSET 296
#define PRTOKEN_ROTATE 297
#define PRTOKEN_TRANSLATE 298
#define PRTOKEN_SCALE 299
#define PRTOKEN_SHEAR 300
#define PRTOKEN_CLEAR_COLOR 301
#define PRTOKEN_INPUT_AREA 302
#define PRTOKEN_ERROR 303
#define PRTOKEN_IDENTIFIER 304
#define PRTOKEN_INTEGER 305
#define PRTOKEN_HEX_INTEGER 306
#define PRTOKEN_FLOAT 307
#define PRTOKEN_TRUE 308
#define PRTOKEN_FALSE 309
#define PRTOKEN_QUOTED_STRING 310
#define PRTOKEN_STEREO_SYSTEM_COMMANDS 311
#define PRTOKEN_CUSTOM_FULL_SCREEN_RECTANGLE 312
#define PRTOKEN_METHOD 313
#define PRTOKEN_PREMULTIPLY 314
#define PRTOKEN_POSTMULTIPLY 315
#define PRTOKEN_OVERRIDE_REDIRECT 316
#define PRTOKEN_SHARELENS 317
#define PRTOKEN_SHAREVIEW 318
#define PRTOKEN_READ_DRAWABLE 319
#define PRTOKEN_SET_RTT_MODE 320
#define PRTOKEN_RTT_MODE_NONE 321
#define PRTOKEN_RTT_MODE_RGB 322
#define PRTOKEN_RTT_MODE_RGBA 323
#define PRTOKEN_THREAD_MODEL 324
#define PRTOKEN_SINGLE_THREADED 325
#define PRTOKEN_THREAD_PER_CAMERA 326
#define PRTOKEN_THREAD_PER_RENDER_SURFACE 327
#define PRTOKEN_STEREO_SETTINGS 328
#define PRTOKEN_MODE 329
#define PRTOKEN_MONO 330
#define PRTOKEN_ANAGLYPHIC 331
#define PRTOKEN_QUAD_BUFFER 332
#define PRTOKEN_VERTICAL_INTERLACE 333
#define PRTOKEN_HORIZONTAL_INTERLACE 334
#define PRTOKEN_EYE_SEPARATION 335
#define PRTOKEN_SCENE_HANDLER 336
#define PRTOKEN_AUTO_NEAR_FAR 337




/* Copy the first part of user declarations.  */
#line 24 ".././/ConfigParser.y"


#ifndef WIN32
#include <unistd.h>
#include <sys/wait.h>
#include <stdlib.h>
#include <fcntl.h>
#endif

#ifndef WIN32
#define SUPPORT_CPP 1
#endif

#include <stdio.h>
#include <fstream>
#include <string>

#include "FlexLexer.h"

#include <Producer/CameraConfig.h>


using namespace std;
using namespace Producer;

static void ConfigParser_error( const char * );
static CameraConfig *cfg = 0L;
static std::string fileName = "(stdin)";

static yyFlexLexer *flexer = 0L;

static int yylex()
{
    if( flexer == 0L )
        fprintf( stderr, "Internal error!\n" );
    return flexer->yylex();
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 146 ".././/ConfigParser.y"
{
    char * string;
    int    integer;
    float  real;
    bool boolean;
}
/* Line 187 of yacc.c.  */
#line 315 "ConfigParser.cpp"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 328 "ConfigParser.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  32
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   319

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  88
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  53
/* YYNRULES -- Number of rules.  */
#define YYNRULES  141
/* YYNRULES -- Number of states.  */
#define YYNSTATES  298

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   337

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    87,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    86,    83,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    84,     2,    85,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    16,    18,
      20,    22,    24,    26,    29,    33,    35,    37,    39,    45,
      50,    52,    53,    55,    58,    59,    66,    68,    71,    72,
      76,    78,    85,    89,    93,   100,   102,   104,   106,   108,
     109,   115,   117,   120,   125,   132,   138,   144,   148,   150,
     152,   157,   159,   162,   163,   172,   183,   190,   199,   208,
     219,   224,   228,   233,   235,   238,   239,   243,   247,   249,
     251,   253,   255,   257,   262,   267,   269,   270,   272,   273,
     280,   282,   285,   286,   290,   292,   299,   306,   310,   314,
     318,   322,   329,   333,   337,   341,   345,   347,   349,   351,
     353,   355,   356,   363,   364,   370,   372,   376,   378,   381,
     384,   387,   389,   391,   393,   396,   399,   402,   405,   408,
     411,   414,   417,   420,   423,   426,   429,   431,   434,   435,
     441,   443,   446,   450,   452,   454,   456,   458,   460,   462,
     464,   466
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      89,     0,    -1,    90,    -1,    91,    -1,    90,    91,    -1,
     125,    -1,   119,    -1,    99,    -1,   130,    -1,    96,    -1,
      95,    -1,    92,    -1,    93,    -1,    92,    93,    -1,    69,
      94,    83,    -1,    70,    -1,    71,    -1,    72,    -1,    56,
     136,   138,   138,    83,    -1,    34,    84,    97,    85,    -1,
      98,    -1,    -1,    99,    -1,    98,    99,    -1,    -1,    35,
     137,   100,    84,   101,    85,    -1,   102,    -1,   101,   102,
      -1,    -1,    24,   137,    83,    -1,   119,    -1,    36,   134,
     134,   134,   134,    83,    -1,    62,   140,    83,    -1,    63,
     140,    83,    -1,    46,   134,   134,   134,   134,    83,    -1,
     108,    -1,   103,    -1,   111,    -1,   115,    -1,    -1,    41,
      84,   104,   105,    85,    -1,   106,    -1,   105,   106,    -1,
      45,   134,   134,    83,    -1,    42,   134,   134,   134,   134,
      83,    -1,    43,   134,   134,   134,    83,    -1,    44,   134,
     134,   134,    83,    -1,    58,   107,    83,    -1,    59,    -1,
      60,    -1,    37,    84,   109,    85,    -1,   110,    -1,   109,
     110,    -1,    -1,    40,   134,   134,   134,   134,   134,   134,
      83,    -1,    40,   134,   134,   134,   134,   134,   134,   134,
     134,    83,    -1,    39,   134,   134,   134,   134,    83,    -1,
      39,   134,   134,   134,   134,   134,   134,    83,    -1,    38,
     134,   134,   134,   134,   134,   134,    83,    -1,    38,   134,
     134,   134,   134,   134,   134,   134,   134,    83,    -1,    45,
     134,   134,    83,    -1,    82,   140,    83,    -1,    73,    84,
     112,    85,    -1,   113,    -1,   112,   113,    -1,    -1,    74,
     114,    83,    -1,    80,   134,    83,    -1,    75,    -1,    76,
      -1,    77,    -1,    78,    -1,    79,    -1,    81,   116,   118,
      83,    -1,   117,    86,    86,   117,    -1,    49,    -1,    -1,
      55,    -1,    -1,    24,   137,   120,    84,   121,    85,    -1,
     122,    -1,   121,   122,    -1,    -1,     3,   137,    83,    -1,
     125,    -1,    25,   136,   136,   136,   136,    83,    -1,    26,
     135,   135,   135,   135,    83,    -1,    27,   137,    83,    -1,
      28,   136,    83,    -1,    29,   136,    83,    -1,    30,   140,
      83,    -1,    57,   136,   136,   136,   136,    83,    -1,    61,
     140,    83,    -1,    31,   123,    83,    -1,    64,   137,    83,
      -1,    65,   124,    83,    -1,    32,    -1,    33,    -1,    66,
      -1,    67,    -1,    68,    -1,    -1,     3,   137,   126,    84,
     128,    85,    -1,    -1,     3,   127,    84,   128,    85,    -1,
     129,    -1,   128,    87,   129,    -1,     4,    -1,     5,   139,
      -1,     6,   136,    -1,     7,   136,    -1,     8,    -1,     9,
      -1,    10,    -1,    11,   136,    -1,    12,   136,    -1,    13,
     136,    -1,    14,   136,    -1,    15,   136,    -1,    16,   136,
      -1,    17,   136,    -1,    18,   136,    -1,    19,   136,    -1,
      20,   136,    -1,    21,   136,    -1,    22,   136,    -1,    23,
      -1,   136,   136,    -1,    -1,    47,   131,    84,   132,    85,
      -1,   133,    -1,   132,   133,    -1,    24,   137,    83,    -1,
      52,    -1,    50,    -1,    52,    -1,    50,    -1,    55,    -1,
      55,    -1,    51,    -1,    53,    -1,    54,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   165,   165,   168,   168,   171,   171,   171,   171,   171,
     171,   171,   174,   174,   178,   186,   187,   188,   191,   197,
     200,   203,   203,   203,   207,   206,   215,   215,   218,   220,
     224,   228,   232,   236,   240,   244,   245,   246,   247,   251,
     250,   260,   260,   264,   268,   272,   276,   280,   287,   288,
     291,   294,   294,   297,   299,   303,   307,   311,   315,   319,
     323,   327,   333,   336,   336,   339,   341,   345,   351,   352,
     353,   354,   355,   358,   363,   371,   377,   378,   384,   383,
     394,   395,   398,   400,   404,   408,   412,   416,   420,   424,
     428,   432,   436,   440,   445,   449,   456,   457,   461,   462,
     463,   468,   467,   477,   476,   487,   487,   490,   494,   499,
     503,   508,   512,   516,   520,   524,   529,   534,   538,   542,
     546,   550,   554,   558,   562,   566,   570,   574,   581,   580,
     586,   586,   590,   596,   600,   607,   613,   619,   625,   632,
     640,   640
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PRTOKEN_PIXEL_ATTRIBUTES",
  "PRTOKEN_SET_SIMPLE", "PRTOKEN_VISUAL_ID", "PRTOKEN_BUFFER_SIZE",
  "PRTOKEN_LEVEL", "PRTOKEN_RGBA", "PRTOKEN_DOUBLEBUFFER",
  "PRTOKEN_STEREO", "PRTOKEN_AUX_BUFFERS", "PRTOKEN_RED_SIZE",
  "PRTOKEN_GREEN_SIZE", "PRTOKEN_BLUE_SIZE", "PRTOKEN_ALPHA_SIZE",
  "PRTOKEN_DEPTH_SIZE", "PRTOKEN_STENCIL_SIZE", "PRTOKEN_ACCUM_RED_SIZE",
  "PRTOKEN_ACCUM_GREEN_SIZE", "PRTOKEN_ACCUM_BLUE_SIZE",
  "PRTOKEN_ACCUM_ALPHA_SIZE", "PRTOKEN_SAMPLES", "PRTOKEN_SAMPLE_BUFFERS",
  "PRTOKEN_RENDER_SURFACE", "PRTOKEN_WINDOW_RECT", "PRTOKEN_INPUT_RECT",
  "PRTOKEN_HOSTNAME", "PRTOKEN_DISPLAY", "PRTOKEN_SCREEN",
  "PRTOKEN_BORDER", "PRTOKEN_DRAWABLE_TYPE", "PRTOKEN_WINDOW_TYPE",
  "PRTOKEN_PBUFFER_TYPE", "PRTOKEN_CAMERA_GROUP", "PRTOKEN_CAMERA",
  "PRTOKEN_PROJECTION_RECT", "PRTOKEN_LENS", "PRTOKEN_FRUSTUM",
  "PRTOKEN_PERSPECTIVE", "PRTOKEN_ORTHO", "PRTOKEN_OFFSET",
  "PRTOKEN_ROTATE", "PRTOKEN_TRANSLATE", "PRTOKEN_SCALE", "PRTOKEN_SHEAR",
  "PRTOKEN_CLEAR_COLOR", "PRTOKEN_INPUT_AREA", "PRTOKEN_ERROR",
  "PRTOKEN_IDENTIFIER", "PRTOKEN_INTEGER", "PRTOKEN_HEX_INTEGER",
  "PRTOKEN_FLOAT", "PRTOKEN_TRUE", "PRTOKEN_FALSE",
  "PRTOKEN_QUOTED_STRING", "PRTOKEN_STEREO_SYSTEM_COMMANDS",
  "PRTOKEN_CUSTOM_FULL_SCREEN_RECTANGLE", "PRTOKEN_METHOD",
  "PRTOKEN_PREMULTIPLY", "PRTOKEN_POSTMULTIPLY",
  "PRTOKEN_OVERRIDE_REDIRECT", "PRTOKEN_SHARELENS", "PRTOKEN_SHAREVIEW",
  "PRTOKEN_READ_DRAWABLE", "PRTOKEN_SET_RTT_MODE", "PRTOKEN_RTT_MODE_NONE",
  "PRTOKEN_RTT_MODE_RGB", "PRTOKEN_RTT_MODE_RGBA", "PRTOKEN_THREAD_MODEL",
  "PRTOKEN_SINGLE_THREADED", "PRTOKEN_THREAD_PER_CAMERA",
  "PRTOKEN_THREAD_PER_RENDER_SURFACE", "PRTOKEN_STEREO_SETTINGS",
  "PRTOKEN_MODE", "PRTOKEN_MONO", "PRTOKEN_ANAGLYPHIC",
  "PRTOKEN_QUAD_BUFFER", "PRTOKEN_VERTICAL_INTERLACE",
  "PRTOKEN_HORIZONTAL_INTERLACE", "PRTOKEN_EYE_SEPARATION",
  "PRTOKEN_SCENE_HANDLER", "PRTOKEN_AUTO_NEAR_FAR", "';'", "'{'", "'}'",
  "':'", "','", "$accept", "config", "entries", "entry", "system_params",
  "system_param", "threadModelDirective", "stereo_param", "camera_group",
  "camera_group_attributes", "cameras", "camera", "@1",
  "camera_attributes", "camera_attribute", "camera_offset", "@2",
  "camera_offset_attributes", "camera_offset_attribute",
  "offset_multiply_method", "lens", "lens_attributes", "lens_attribute",
  "stereo_settings", "stereo_setting_attributes",
  "stereo_setting_attribute", "stereo_mode", "scene_handler",
  "library_class", "identifier", "args", "render_surface", "@3",
  "render_surface_attributes", "render_surface_attribute", "drawableType",
  "rtt_mode", "visual", "@4", "@5", "pixel_attributes", "pixel_attribute",
  "input_area", "@6", "input_area_entries", "input_area_entry", "real",
  "floatparam", "intparam", "name", "string", "hex_integer", "bool", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    59,   123,   125,    58,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    88,    89,    90,    90,    91,    91,    91,    91,    91,
      91,    91,    92,    92,    93,    94,    94,    94,    95,    96,
      97,    98,    98,    98,   100,    99,   101,   101,   102,   102,
     102,   102,   102,   102,   102,   102,   102,   102,   102,   104,
     103,   105,   105,   106,   106,   106,   106,   106,   107,   107,
     108,   109,   109,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   111,   112,   112,   113,   113,   113,   114,   114,
     114,   114,   114,   115,   116,   117,   118,   118,   120,   119,
     121,   121,   122,   122,   122,   122,   122,   122,   122,   122,
     122,   122,   122,   122,   122,   122,   123,   123,   124,   124,
     124,   126,   125,   127,   125,   128,   128,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   131,   130,
     132,   132,   133,   134,   134,   135,   136,   137,   138,   139,
     140,   140
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     1,     1,     1,     5,     4,
       1,     0,     1,     2,     0,     6,     1,     2,     0,     3,
       1,     6,     3,     3,     6,     1,     1,     1,     1,     0,
       5,     1,     2,     4,     6,     5,     5,     3,     1,     1,
       4,     1,     2,     0,     8,    10,     6,     8,     8,    10,
       4,     3,     4,     1,     2,     0,     3,     3,     1,     1,
       1,     1,     1,     4,     4,     1,     0,     1,     0,     6,
       1,     2,     0,     3,     1,     6,     6,     3,     3,     3,
       3,     6,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     0,     6,     0,     5,     1,     3,     1,     2,     2,
       2,     1,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     0,     5,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,   103,     0,     0,     0,   128,     0,     0,     0,     2,
       3,    11,    12,    10,     9,     7,     6,     5,     8,   137,
       0,   101,    78,    21,    24,     0,   136,     0,    15,    16,
      17,     0,     1,     4,    13,     0,     0,     0,     0,    20,
      22,     0,     0,   138,     0,    14,   107,     0,     0,     0,
     111,   112,   113,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   126,     0,   105,     0,     0,
      82,    19,    23,    28,     0,     0,   130,     0,   139,   108,
     109,   110,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   104,     0,   127,     0,   103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,    84,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    26,    36,    35,    37,    38,    30,     0,
     129,   131,    18,   106,   102,   101,     0,   135,     0,     0,
       0,     0,   140,   141,     0,    96,    97,     0,     0,     0,
       0,    98,    99,   100,     0,    79,    81,    78,   134,   133,
       0,    53,    39,     0,     0,     0,    65,    75,    76,     0,
      25,    27,   132,    83,     0,     0,    87,    88,    89,    90,
      93,     0,    92,    94,    95,    29,     0,     0,     0,     0,
       0,     0,     0,    51,     0,     0,    32,    33,     0,     0,
       0,    63,    77,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    50,    52,     0,     0,     0,     0,
       0,     0,    41,     0,    68,    69,    70,    71,    72,     0,
       0,    62,    64,    73,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    61,     0,     0,     0,     0,    48,    49,
       0,    40,    42,     0,    66,    67,    74,    85,    86,    91,
      31,     0,     0,     0,    60,     0,     0,     0,     0,    47,
      34,     0,     0,     0,     0,     0,     0,    43,     0,    56,
       0,     0,     0,    45,    46,     0,     0,     0,    44,    58,
       0,    57,    54,     0,     0,     0,    59,    55
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     8,     9,    10,    11,    12,    31,    13,    14,    38,
      39,    15,    41,   122,   123,   124,   194,   221,   222,   250,
     125,   192,   193,   126,   200,   201,   229,   127,   168,   169,
     203,    16,    37,   110,   111,   147,   154,    17,    36,    20,
      66,    67,    18,    25,    75,    76,   160,   138,    68,    21,
      44,    79,   144
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -137
static const yytype_int16 yypact[] =
{
      79,   -52,   -52,   -78,   -52,  -137,   -34,     9,    20,    79,
    -137,   -44,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
     -10,  -137,  -137,     6,  -137,     0,  -137,    36,  -137,  -137,
    -137,    11,  -137,  -137,  -137,   269,    17,    31,    39,     6,
    -137,    37,   107,  -137,    36,  -137,  -137,    85,   -34,   -34,
    -137,  -137,  -137,   -34,   -34,   -34,   -34,   -34,   -34,   -34,
     -34,   -34,   -34,   -34,   -34,  -137,   -41,  -137,   -34,   269,
     179,  -137,  -137,   191,   -52,   -20,  -137,    60,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,   269,  -137,   -26,   -52,   -34,
      99,   -52,   -34,   -34,   -23,   101,   -34,   -23,   -52,    61,
       7,  -137,  -137,   -52,    52,    68,    73,    52,   -23,   -23,
      74,   110,   176,  -137,  -137,  -137,  -137,  -137,  -137,    77,
    -137,  -137,  -137,  -137,  -137,    81,   -34,  -137,    99,    87,
      93,    94,  -137,  -137,    96,  -137,  -137,   100,   -34,   103,
     105,  -137,  -137,  -137,   106,  -137,  -137,   108,  -137,  -137,
      52,    38,  -137,    52,   109,   112,   -59,  -137,   129,   116,
    -137,  -137,  -137,  -137,   -34,    99,  -137,  -137,  -137,  -137,
    -137,   -34,  -137,  -137,  -137,  -137,    52,    52,    52,    52,
      52,   -23,   -16,  -137,   251,    52,  -137,  -137,   190,    52,
     -66,  -137,  -137,   114,   117,   -34,    99,   -34,    52,    52,
      52,    52,    52,   115,  -137,  -137,    52,    52,    52,    52,
      90,   111,  -137,    52,  -137,  -137,  -137,  -137,  -137,   128,
     131,  -137,  -137,  -137,   110,   133,   135,   136,   137,    52,
      52,    52,   138,  -137,    52,    52,    52,    52,  -137,  -137,
     140,  -137,  -137,   141,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,    52,    52,    52,  -137,    52,    52,    52,   142,  -137,
    -137,    52,   -43,    52,    52,   143,   146,  -137,    52,  -137,
      52,    52,   147,  -137,  -137,    23,   148,    55,  -137,  -137,
      52,  -137,  -137,    52,   150,   151,  -137,  -137
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -137,  -137,  -137,   185,  -137,   224,  -137,  -137,  -137,  -137,
    -137,   -12,  -137,  -137,   119,  -137,  -137,  -137,    21,  -137,
    -137,  -137,    53,  -137,  -137,    46,  -137,  -137,  -137,    13,
    -137,   -55,  -137,  -137,   145,  -137,  -137,   -65,  -137,  -137,
     181,   153,  -137,  -137,  -137,   177,  -100,  -136,    -6,    24,
     207,  -137,  -106
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
      27,   149,   175,    19,    74,   112,    23,   158,   198,   159,
      98,    40,   164,   165,   199,   198,    26,   163,   128,   231,
      32,   199,   187,   188,   189,     7,    22,    72,    24,   190,
     142,   143,    99,   100,   101,   102,   103,   104,   105,   206,
     279,     4,    80,    81,    94,   112,    95,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,   134,
     186,    95,    96,   195,   106,   130,   191,   128,   107,   214,
     236,   108,   109,   158,    35,   159,   187,   188,   189,    28,
      29,    30,     1,   190,    42,   213,   208,   209,   210,   211,
     212,    43,   155,   136,    45,   223,   140,   141,   129,   230,
     148,    69,   158,     2,   159,   158,   289,   159,   238,   239,
     240,   241,   242,     3,     4,    70,   244,   245,   246,   247,
     191,    73,   135,   253,    71,   139,     5,   151,   152,   153,
     174,    74,   150,   145,   146,     6,    78,   157,   292,   261,
     262,   263,   181,   132,   265,   266,   267,   268,     7,   248,
     249,   137,   161,   216,   217,   218,   219,   162,   166,   167,
     172,   271,   272,   273,   173,   274,   275,   276,   205,   220,
     176,   278,   280,   281,   282,   207,   177,   178,   285,   179,
     286,   287,    98,   180,   202,   290,   182,   293,   183,   184,
     294,   185,   196,   295,    33,   197,   251,   233,   243,   235,
     113,   237,   204,   234,    99,   100,   101,   102,   103,   104,
     105,   254,   114,   115,   255,   113,   257,   116,   258,   259,
     260,   264,   117,   269,   270,   277,   283,   114,   115,   284,
     288,   291,   116,   296,   297,    34,   106,   117,   118,   119,
     107,   171,   252,   108,   109,   215,   232,   256,   133,   120,
      97,    77,   131,   118,   119,   156,     0,   121,     0,     0,
       0,   170,     0,     0,   120,   224,   225,   226,   227,   228,
       0,     0,   121,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,   216,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    26
};

static const yytype_int16 yycheck[] =
{
       6,   107,   138,    55,    24,    70,    84,    50,    74,    52,
       3,    23,   118,   119,    80,    74,    50,   117,    73,    85,
       0,    80,    38,    39,    40,    69,     2,    39,     4,    45,
      53,    54,    25,    26,    27,    28,    29,    30,    31,   175,
      83,    35,    48,    49,    85,   110,    87,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    85,
     160,    87,    68,   163,    57,    85,    82,   122,    61,    85,
     206,    64,    65,    50,    84,    52,    38,    39,    40,    70,
      71,    72,     3,    45,    84,   191,   186,   187,   188,   189,
     190,    55,    85,    99,    83,   195,   102,   103,    74,   199,
     106,    84,    50,    24,    52,    50,    83,    52,   208,   209,
     210,   211,   212,    34,    35,    84,   216,   217,   218,   219,
      82,    84,    98,   223,    85,   101,    47,    66,    67,    68,
     136,    24,   108,    32,    33,    56,    51,   113,    83,   239,
     240,   241,   148,    83,   244,   245,   246,   247,    69,    59,
      60,    52,    84,    42,    43,    44,    45,    84,    84,    49,
      83,   261,   262,   263,    83,   265,   266,   267,   174,    58,
      83,   271,   272,   273,   274,   181,    83,    83,   278,    83,
     280,   281,     3,    83,    55,   285,    83,   287,    83,    83,
     290,    83,    83,   293,     9,    83,    85,    83,    83,   205,
      24,   207,    86,    86,    25,    26,    27,    28,    29,    30,
      31,    83,    36,    37,    83,    24,    83,    41,    83,    83,
      83,    83,    46,    83,    83,    83,    83,    36,    37,    83,
      83,    83,    41,    83,    83,    11,    57,    46,    62,    63,
      61,   122,   221,    64,    65,   192,   200,   234,    95,    73,
      69,    44,    75,    62,    63,   110,    -1,    81,    -1,    -1,
      -1,    85,    -1,    -1,    73,    75,    76,    77,    78,    79,
      -1,    -1,    81,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    42,    43,    44,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    24,    34,    35,    47,    56,    69,    89,    90,
      91,    92,    93,    95,    96,    99,   119,   125,   130,    55,
     127,   137,   137,    84,   137,   131,    50,   136,    70,    71,
      72,    94,     0,    91,    93,    84,   126,   120,    97,    98,
      99,   100,    84,    55,   138,    83,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,   128,   129,   136,    84,
      84,    85,    99,    84,    24,   132,   133,   138,    51,   139,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   136,   136,   136,    85,    87,   136,   128,     3,    25,
      26,    27,    28,    29,    30,    31,    57,    61,    64,    65,
     121,   122,   125,    24,    36,    37,    41,    46,    62,    63,
      73,    81,   101,   102,   103,   108,   111,   115,   119,   137,
      85,   133,    83,   129,    85,   137,   136,    52,   135,   137,
     136,   136,    53,    54,   140,    32,    33,   123,   136,   140,
     137,    66,    67,    68,   124,    85,   122,   137,    50,    52,
     134,    84,    84,   134,   140,   140,    84,    49,   116,   117,
      85,   102,    83,    83,   136,   135,    83,    83,    83,    83,
      83,   136,    83,    83,    83,    83,   134,    38,    39,    40,
      45,    82,   109,   110,   104,   134,    83,    83,    74,    80,
     112,   113,    55,   118,    86,   136,   135,   136,   134,   134,
     134,   134,   134,   140,    85,   110,    42,    43,    44,    45,
      58,   105,   106,   134,    75,    76,    77,    78,    79,   114,
     134,    85,   113,    83,    86,   136,   135,   136,   134,   134,
     134,   134,   134,    83,   134,   134,   134,   134,    59,    60,
     107,    85,   106,   134,    83,    83,   117,    83,    83,    83,
      83,   134,   134,   134,    83,   134,   134,   134,   134,    83,
      83,   134,   134,   134,   134,   134,   134,    83,   134,    83,
     134,   134,   134,    83,    83,   134,   134,   134,    83,    83,
     134,    83,    83,   134,   134,   134,    83,    83
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 14:
#line 179 ".././/ConfigParser.y"
    {
            Producer::CameraGroup::ThreadModel tm = (Producer::CameraGroup::ThreadModel)(yyvsp[(2) - (3)].integer);
            cfg->setThreadModelDirective( tm );
        ;}
    break;

  case 15:
#line 186 ".././/ConfigParser.y"
    { (yyval.integer) = CameraGroup::SingleThreaded; ;}
    break;

  case 16:
#line 187 ".././/ConfigParser.y"
    { (yyval.integer) = CameraGroup::ThreadPerCamera; ;}
    break;

  case 17:
#line 188 ".././/ConfigParser.y"
    { (yyval.integer) = CameraGroup::ThreadPerRenderSurface; ;}
    break;

  case 18:
#line 192 ".././/ConfigParser.y"
    {
           cfg->addStereoSystemCommand( (yyvsp[(2) - (5)].integer), (yyvsp[(3) - (5)].string), (yyvsp[(4) - (5)].string) );
        ;}
    break;

  case 24:
#line 207 ".././/ConfigParser.y"
    {
	    cfg->beginCamera( (yyvsp[(2) - (2)].string) );
	 ;}
    break;

  case 25:
#line 211 ".././/ConfigParser.y"
    {
	    cfg->endCamera();
	 ;}
    break;

  case 29:
#line 221 ".././/ConfigParser.y"
    {
	    cfg->setCameraRenderSurface( (yyvsp[(2) - (3)].string) );
	;}
    break;

  case 30:
#line 225 ".././/ConfigParser.y"
    {
	    cfg->setCameraRenderSurface();
	;}
    break;

  case 31:
#line 229 ".././/ConfigParser.y"
    {
	    cfg->setCameraProjectionRectangle( (yyvsp[(2) - (6)].real), (yyvsp[(3) - (6)].real), (yyvsp[(4) - (6)].real), (yyvsp[(5) - (6)].real) );
	;}
    break;

  case 32:
#line 233 ".././/ConfigParser.y"
    {
	    cfg->setCameraShareLens( (yyvsp[(2) - (3)].boolean) );
	;}
    break;

  case 33:
#line 237 ".././/ConfigParser.y"
    {
        cfg->setCameraShareView( (yyvsp[(2) - (3)].boolean) );
    ;}
    break;

  case 34:
#line 241 ".././/ConfigParser.y"
    {
        cfg->setCameraClearColor( (yyvsp[(2) - (6)].real), (yyvsp[(3) - (6)].real), (yyvsp[(4) - (6)].real), (yyvsp[(5) - (6)].real) );
    ;}
    break;

  case 39:
#line 251 ".././/ConfigParser.y"
    {
	    cfg->beginCameraOffset();
	;}
    break;

  case 40:
#line 255 ".././/ConfigParser.y"
    {
	    cfg->endCameraOffset();
	;}
    break;

  case 43:
#line 265 ".././/ConfigParser.y"
    {
	    cfg->shearCameraOffset( (yyvsp[(2) - (4)].real), (yyvsp[(3) - (4)].real) );
	  ;}
    break;

  case 44:
#line 269 ".././/ConfigParser.y"
    {
	    cfg->rotateCameraOffset( (yyvsp[(2) - (6)].real), (yyvsp[(3) - (6)].real), (yyvsp[(4) - (6)].real), (yyvsp[(5) - (6)].real) );
	  ;}
    break;

  case 45:
#line 273 ".././/ConfigParser.y"
    {
	    cfg->translateCameraOffset( (yyvsp[(2) - (5)].real), (yyvsp[(3) - (5)].real), (yyvsp[(4) - (5)].real) );
	  ;}
    break;

  case 46:
#line 277 ".././/ConfigParser.y"
    {
	    cfg->scaleCameraOffset( (yyvsp[(2) - (5)].real), (yyvsp[(3) - (5)].real), (yyvsp[(4) - (5)].real) );
	  ;}
    break;

  case 47:
#line 281 ".././/ConfigParser.y"
    {
	    cfg->setCameraOffsetMultiplyMethod( (Producer::Camera::Offset::MultiplyMethod)(yyvsp[(2) - (3)].integer) );
	  ;}
    break;

  case 48:
#line 287 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::Offset::PreMultiply; ;}
    break;

  case 49:
#line 288 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::Offset::PostMultiply; ;}
    break;

  case 54:
#line 300 ".././/ConfigParser.y"
    {
	      cfg->setCameraOrtho( (yyvsp[(2) - (8)].real), (yyvsp[(3) - (8)].real), (yyvsp[(4) - (8)].real), (yyvsp[(5) - (8)].real), (yyvsp[(6) - (8)].real), (yyvsp[(7) - (8)].real) );
	  ;}
    break;

  case 55:
#line 304 ".././/ConfigParser.y"
    {
	      cfg->setCameraOrtho( (yyvsp[(2) - (10)].real), (yyvsp[(3) - (10)].real), (yyvsp[(4) - (10)].real), (yyvsp[(5) - (10)].real), (yyvsp[(6) - (10)].real), (yyvsp[(7) - (10)].real), (yyvsp[(8) - (10)].real), (yyvsp[(9) - (10)].real) );
	  ;}
    break;

  case 56:
#line 308 ".././/ConfigParser.y"
    {
	      cfg->setCameraPerspective( (yyvsp[(2) - (6)].real), (yyvsp[(3) - (6)].real), (yyvsp[(4) - (6)].real), (yyvsp[(5) - (6)].real) );
	  ;}
    break;

  case 57:
#line 312 ".././/ConfigParser.y"
    {
	      cfg->setCameraPerspective( (yyvsp[(2) - (8)].real), (yyvsp[(3) - (8)].real), (yyvsp[(4) - (8)].real), (yyvsp[(5) - (8)].real), (yyvsp[(6) - (8)].real), (yyvsp[(7) - (8)].real) );
	  ;}
    break;

  case 58:
#line 316 ".././/ConfigParser.y"
    {
	      cfg->setCameraFrustum( (yyvsp[(2) - (8)].real), (yyvsp[(3) - (8)].real), (yyvsp[(4) - (8)].real), (yyvsp[(5) - (8)].real), (yyvsp[(6) - (8)].real), (yyvsp[(7) - (8)].real) );
	  ;}
    break;

  case 59:
#line 320 ".././/ConfigParser.y"
    {
	      cfg->setCameraFrustum( (yyvsp[(2) - (10)].real), (yyvsp[(3) - (10)].real), (yyvsp[(4) - (10)].real), (yyvsp[(5) - (10)].real), (yyvsp[(6) - (10)].real), (yyvsp[(7) - (10)].real), (yyvsp[(8) - (10)].real), (yyvsp[(9) - (10)].real) );
	  ;}
    break;

  case 60:
#line 324 ".././/ConfigParser.y"
    {
	      cfg->setCameraLensShear( (yyvsp[(2) - (4)].real), (yyvsp[(3) - (4)].real) );
	  ;}
    break;

  case 61:
#line 328 ".././/ConfigParser.y"
    {
          cfg->setCameraLensAutoNearFar( (yyvsp[(2) - (3)].boolean) );
      ;}
    break;

  case 66:
#line 342 ".././/ConfigParser.y"
    {
                 cfg->setCameraStereoSettingsMode( (Producer::Camera::StereoSettings::Mode)(yyvsp[(2) - (3)].integer) );
             ;}
    break;

  case 67:
#line 346 ".././/ConfigParser.y"
    {
                 cfg->setCameraStereoSettingsEyeSeparation( (yyvsp[(2) - (3)].real) );
            ;}
    break;

  case 68:
#line 351 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::StereoSettings::Mono; ;}
    break;

  case 69:
#line 352 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::StereoSettings::Anaglyphic; ;}
    break;

  case 70:
#line 353 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::StereoSettings::QuadBuffer; ;}
    break;

  case 71:
#line 354 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::StereoSettings::VerticalInterlace; ;}
    break;

  case 72:
#line 355 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::StereoSettings::HorizontalInterlace; ;}
    break;

  case 73:
#line 359 ".././/ConfigParser.y"
    {
                cfg->setCameraSceneHandler( (yyvsp[(2) - (4)].string), (yyvsp[(3) - (4)].string) );
            ;}
    break;

  case 74:
#line 364 ".././/ConfigParser.y"
    {
                char  buff[256];
                sprintf( buff, "%s::%s", (yyvsp[(1) - (4)].string), (yyvsp[(4) - (4)].string) );

                (yyval.string) = strdup( buff );
            ;}
    break;

  case 75:
#line 372 ".././/ConfigParser.y"
    {
	            (yyval.string) = strdup( flexer->YYText() );
            ;}
    break;

  case 76:
#line 377 ".././/ConfigParser.y"
    { ; ;}
    break;

  case 77:
#line 379 ".././/ConfigParser.y"
    {
	        (yyval.string) = strdup( flexer->YYText() );
        ;}
    break;

  case 78:
#line 384 ".././/ConfigParser.y"
    {
	     cfg->beginRenderSurface( (yyvsp[(2) - (2)].string) );
	 ;}
    break;

  case 79:
#line 388 ".././/ConfigParser.y"
    {
	     cfg->endRenderSurface();
	 ;}
    break;

  case 83:
#line 401 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceVisualChooser( (yyvsp[(2) - (3)].string) );
	;}
    break;

  case 84:
#line 405 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceVisualChooser();
	;}
    break;

  case 85:
#line 409 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceWindowRectangle( (yyvsp[(2) - (6)].integer), (yyvsp[(3) - (6)].integer), (yyvsp[(4) - (6)].integer), (yyvsp[(5) - (6)].integer) );
	;}
    break;

  case 86:
#line 413 ".././/ConfigParser.y"
    {
        cfg->setRenderSurfaceInputRectangle( (yyvsp[(2) - (6)].real), (yyvsp[(3) - (6)].real), (yyvsp[(4) - (6)].real), (yyvsp[(5) - (6)].real) );
    ;}
    break;

  case 87:
#line 417 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceHostName( std::string((yyvsp[(2) - (3)].string)) );
	;}
    break;

  case 88:
#line 421 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceDisplayNum( (yyvsp[(2) - (3)].integer) );
	;}
    break;

  case 89:
#line 425 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceScreen( (yyvsp[(2) - (3)].integer) );
	;}
    break;

  case 90:
#line 429 ".././/ConfigParser.y"
    {    
	    cfg->setRenderSurfaceBorder( (yyvsp[(2) - (3)].boolean) );
	;}
    break;

  case 91:
#line 433 ".././/ConfigParser.y"
    {
        cfg->setRenderSurfaceCustomFullScreenRectangle( (yyvsp[(2) - (6)].integer), (yyvsp[(3) - (6)].integer), (yyvsp[(4) - (6)].integer), (yyvsp[(5) - (6)].integer) );
    ;}
    break;

  case 92:
#line 437 ".././/ConfigParser.y"
    {
        cfg->setRenderSurfaceOverrideRedirect( (yyvsp[(2) - (3)].boolean) );
    ;}
    break;

  case 93:
#line 441 ".././/ConfigParser.y"
    {
        Producer::RenderSurface::DrawableType drawableType = (RenderSurface::DrawableType)(yyvsp[(2) - (3)].integer);
        cfg->setRenderSurfaceDrawableType( drawableType );
    ;}
    break;

  case 94:
#line 446 ".././/ConfigParser.y"
    {
        cfg->setRenderSurfaceReadDrawable( (yyvsp[(2) - (3)].string) );
    ;}
    break;

  case 95:
#line 450 ".././/ConfigParser.y"
    {
        cfg->setRenderSurfaceRenderToTextureMode( (Producer::RenderSurface::RenderToTextureMode)(yyvsp[(2) - (3)].integer) );
    ;}
    break;

  case 96:
#line 456 ".././/ConfigParser.y"
    { (yyval.integer) =  RenderSurface::DrawableType_Window; ;}
    break;

  case 97:
#line 457 ".././/ConfigParser.y"
    { (yyval.integer) =  RenderSurface::DrawableType_PBuffer; ;}
    break;

  case 98:
#line 461 ".././/ConfigParser.y"
    { (yyval.integer) = RenderSurface::RenderToTextureMode_None; ;}
    break;

  case 99:
#line 462 ".././/ConfigParser.y"
    { (yyval.integer) = RenderSurface::RenderToRGBTexture; ;}
    break;

  case 100:
#line 463 ".././/ConfigParser.y"
    { (yyval.integer) = RenderSurface::RenderToRGBATexture; ;}
    break;

  case 101:
#line 468 ".././/ConfigParser.y"
    {
	     cfg->beginVisual( (yyvsp[(2) - (2)].string) );
	 ;}
    break;

  case 102:
#line 472 ".././/ConfigParser.y"
    {
	     cfg->endVisual();
	 ;}
    break;

  case 103:
#line 477 ".././/ConfigParser.y"
    {
	     cfg->beginVisual();
	 ;}
    break;

  case 104:
#line 481 ".././/ConfigParser.y"
    {
	     cfg->endVisual();
	 ;}
    break;

  case 107:
#line 491 ".././/ConfigParser.y"
    {
	      cfg->setVisualSimpleConfiguration();
	  ;}
    break;

  case 108:
#line 495 ".././/ConfigParser.y"
    {
	      cfg->setVisualByID( (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 109:
#line 500 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::BufferSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 110:
#line 504 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::Level, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 111:
#line 509 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::RGBA );
	  ;}
    break;

  case 112:
#line 513 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::DoubleBuffer );
	  ;}
    break;

  case 113:
#line 517 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::Stereo );
	  ;}
    break;

  case 114:
#line 521 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AuxBuffers, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 115:
#line 525 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::RedSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 116:
#line 530 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::GreenSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 117:
#line 535 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::BlueSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 118:
#line 539 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AlphaSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 119:
#line 543 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::DepthSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 120:
#line 547 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::StencilSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 121:
#line 551 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AccumRedSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 122:
#line 555 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AccumGreenSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 123:
#line 559 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AccumBlueSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 124:
#line 563 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AccumAlphaSize, (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 125:
#line 567 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::Samples, (yyvsp[(2) - (2)].integer) );
      ;}
    break;

  case 126:
#line 571 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::SampleBuffers );
	  ;}
    break;

  case 127:
#line 575 ".././/ConfigParser.y"
    {
	      cfg->addVisualExtendedAttribute( (yyvsp[(1) - (2)].integer), (yyvsp[(2) - (2)].integer) );
	  ;}
    break;

  case 128:
#line 581 ".././/ConfigParser.y"
    { cfg->beginInputArea(); ;}
    break;

  case 129:
#line 583 ".././/ConfigParser.y"
    { cfg->endInputArea(); ;}
    break;

  case 132:
#line 591 ".././/ConfigParser.y"
    {
			cfg->addInputAreaEntry( (yyvsp[(2) - (3)].string) );
		;}
    break;

  case 133:
#line 597 ".././/ConfigParser.y"
    {
	    (yyval.real) = atof(flexer->YYText());
	;}
    break;

  case 134:
#line 601 ".././/ConfigParser.y"
    {
	    (yyval.real) = atof(flexer->YYText());
	;}
    break;

  case 135:
#line 608 ".././/ConfigParser.y"
    {
	    (yyval.real) = atof(flexer->YYText());
	;}
    break;

  case 136:
#line 614 ".././/ConfigParser.y"
    {
	    (yyval.integer) = atoi( flexer->YYText() );
	;}
    break;

  case 137:
#line 620 ".././/ConfigParser.y"
    {
	    (yyval.string) = strdup( flexer->YYText() );
	;}
    break;

  case 138:
#line 626 ".././/ConfigParser.y"
    {
	    (yyval.string) = strdup( flexer->YYText() );
	;}
    break;

  case 139:
#line 633 ".././/ConfigParser.y"
    {
	    int n;
	    sscanf( flexer->YYText(), "0x%x", &n );
	    (yyval.integer) = n;
	;}
    break;

  case 140:
#line 640 ".././/ConfigParser.y"
    { (yyval.boolean) = true;;}
    break;

  case 141:
#line 640 ".././/ConfigParser.y"
    { (yyval.boolean) = false; ;}
    break;


/* Line 1267 of yacc.c.  */
#line 2485 "ConfigParser.cpp"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 643 ".././/ConfigParser.y"


static void yyerror( const char *errmsg )
{
    fprintf( stderr, 
    	"CameraConfig::parseFile(\"%s\") : %s - Line %d at or before \"%s\"\n",
		fileName.c_str(),
		errmsg, 
        flexer->lineno(),
        flexer->YYText() );
}

bool CameraConfig::parseFile( const std::string &file )
{
    fileName.clear();

    fileName = findFile(file);

    if( fileName.empty() )
    {
        fprintf( stderr, "CameraConfig::parseFile() - Can't find file \"%s\".\n", file.c_str() );
        return false;
    }

    bool retval = true;

#if defined (SUPPORT_CPP)

    char *cpp_path =
  #if defined(__APPLE__)
                "/usr/bin/cpp";
  #else
                "/lib/cpp";
  #endif

    if( access( cpp_path, X_OK ) == 0 )
    {

        int pd[2];
        pipe( pd );

        flexer = new yyFlexLexer;
        if( fork() == 0 )
        {
            // we don't want to read from the pipe in the child, so close it.
            close( pd[0] );
            close( 1 );
            dup( pd[1] );


            /* This was here to allow reading a config file from stdin.
             * This has never been directly supported, so commenting out.
            if( fileName.empty() )
                execlp( cpp_path, "cpp",  "-P", 0L );
            else
            */
            execlp( cpp_path, "cpp",  "-P", fileName.c_str(), 0L );

            // This should not execute unless an error happens
            perror( "execlp" );
        }
        else
        {
            close( pd[1]);
            close( 0 );
            dup( pd[0] );

            cfg = this;

            retval = ConfigParser_parse() == 0 ? true : false;

            // Wait on child process to finish
            int stat;
            wait( &stat );
        }
    }
    else
#endif
    {
        std::ifstream ifs(fileName.c_str());
        flexer = new yyFlexLexer(&ifs);
        cfg = this;
        retval = ConfigParser_parse() == 0 ? true : false;
        ifs.close();
        delete flexer;
    }
    return retval;
}


